SystemOrganization addCategory: #'Magritte-Core-Description'!
SystemOrganization addCategory: #'Magritte-Core-Accessor'!
SystemOrganization addCategory: #'Magritte-Core-Comparator'!
SystemOrganization addCategory: #'Magritte-Core-Builder'!
SystemOrganization addCategory: #'Magritte-Core-Utility'!

ProtoObject subclass: #MAProxyObject
	instanceVariableNames: 'realSubject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Utility'!

MAProxyObject subclass: #MADynamicObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Utility'!

!MADynamicObject methodsFor: 'accessing' stamp: 'lr 3/10/2005 11:44'!
realSubject
	^super realSubject value.! !

!MAProxyObject class methodsFor: 'instance creation' stamp: 'lr 1/1/2005 15:58'!
on: anObject
	^self basicNew realSubject: anObject.! !

!MAProxyObject methodsFor: 'private' stamp: 'lr 2/28/2005 16:05'!
doesNotUnderstand: aMessage
	^self realSubject
		perform: aMessage selector
		withArguments: aMessage arguments.! !

!MAProxyObject methodsFor: 'testing' stamp: 'lr 2/28/2005 16:05'!
isNil
	^self realSubject isNil.! !

!MAProxyObject methodsFor: 'printing' stamp: 'lr 2/28/2005 16:05'!
printOn: aStream
	aStream nextPut: $[; print: self realSubject; nextPut: $].! !

!MAProxyObject methodsFor: 'printing' stamp: 'lr 2/28/2005 16:05'!
printString
	^String streamContents: [ :stream | self printOn: stream ].! !

!MAProxyObject methodsFor: 'accessing' stamp: 'lr 2/28/2005 16:05'!
realSubject
	^realSubject! !

!MAProxyObject methodsFor: 'accessing' stamp: 'lr 2/28/2005 16:05'!
realSubject: anObject
	realSubject := anObject! !

!UndefinedObject methodsFor: '*Magritte-Core-converting' stamp: 'lr 3/10/2005 22:21'!
asLabel
	^ 'n/a'! !

Error subclass: #MAError
	instanceVariableNames: 'wrapper resumable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Utility'!

MAError subclass: #MAConcurrentError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Utility'!

!MAError class methodsFor: 'instance creation' stamp: 'lr 4/7/2005 22:26'!
wrapper: aWrapper message: aString
	^self wrapper: aWrapper message: aString resumable: false.! !

!MAError class methodsFor: 'instance creation' stamp: 'lr 4/7/2005 22:26'!
wrapper: aWrapper message: aString resumable: aBoolean
	^self new
		wrapper: aWrapper;
		resumable: aBoolean;
		signal: aString.! !

!MAError methodsFor: 'accessing-dynamic' stamp: 'lr 4/7/2005 22:29'!
accessor
	^self wrapper accessor.! !

!MAError methodsFor: 'accessing-dynamic' stamp: 'lr 4/7/2005 22:28'!
description
	^self wrapper description.! !

!MAError methodsFor: 'testing' stamp: 'lr 3/21/2005 13:50'!
isResumable
	^self resumable.! !

!MAError methodsFor: 'accessing' stamp: 'lr 3/21/2005 13:49'!
resumable
	^resumable! !

!MAError methodsFor: 'accessing' stamp: 'lr 3/21/2005 13:50'!
resumable: aBoolean
	resumable := aBoolean! !

!MAError methodsFor: 'accessing' stamp: 'lr 4/7/2005 22:28'!
wrapper
	^wrapper! !

!MAError methodsFor: 'accessing' stamp: 'lr 4/7/2005 22:28'!
wrapper: aWrapper
	wrapper := aWrapper! !

MAError subclass: #MAReadonlyError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Utility'!

MAError subclass: #MARequiredError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Utility'!

MAError subclass: #MAValidationError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Utility'!

!False methodsFor: '*Magritte-Core-converting' stamp: 'lr 3/10/2005 22:21'!
asLabel
	^ 'no'! !

Object subclass: #MAAccessor
	instanceVariableNames: 'description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Accessor'!

!MAAccessor class methodsFor: 'testing' stamp: 'lr 3/30/2005 16:36'!
isAbstract
	^true! !

!MAAccessor class methodsFor: 'instance creation' stamp: 'lr 3/30/2005 16:36'!
new
	"Create a new instance of the receiving class and checks if it is concrete."

	self isAbstract
		ifTrue: [ self error: self name , ' is abstract.' ].
	^super new.! !

!MAAccessor class methodsFor: 'instance creation' stamp: 'lr 3/30/2005 14:23'!
on: aDescription
	^self new
		setDescription: aDescription;
		yourself.! !

!MAAccessor methodsFor: 'accessing' stamp: 'lr 3/30/2005 14:16'!
description
	^description! !

!MAAccessor methodsFor: 'copying' stamp: 'lr 3/30/2005 14:16'!
postCopy
	super postCopy.
	self setDescription: nil.! !

!MAAccessor methodsFor: 'initialization' stamp: 'lr 3/30/2005 14:12'!
setDescription: aDescription
	description := aDescription! !

MAAccessor subclass: #MAModelAccessor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Accessor'!

MAModelAccessor subclass: #MABlockAccessor
	instanceVariableNames: 'readBlock writeBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Accessor'!

!MABlockAccessor class methodsFor: 'testing' stamp: 'lr 3/30/2005 16:36'!
isAbstract
	^false! !

!MABlockAccessor class methodsFor: 'instance creation' stamp: 'lr 3/30/2005 14:26'!
read: aReadBlock write: aWriteBlock
	^self new
		readBlock: aReadBlock;
		writeBlock: aWriteBlock;
		yourself.! !

!MABlockAccessor methodsFor: 'model' stamp: 'lr 3/27/2005 10:01'!
read: aModel
	^self readBlock value: aModel.! !

!MABlockAccessor methodsFor: 'accessing' stamp: 'lr 3/27/2005 10:01'!
readBlock
	^readBlock! !

!MABlockAccessor methodsFor: 'accessing' stamp: 'lr 3/27/2005 10:01'!
readBlock: aBlock
	readBlock := aBlock! !

!MABlockAccessor methodsFor: 'model' stamp: 'lr 3/28/2005 23:04'!
write: anObject to: aModel
	self writeBlock value: aModel value: anObject.! !

!MABlockAccessor methodsFor: 'accessing' stamp: 'lr 3/27/2005 10:02'!
writeBlock
	^writeBlock! !

!MABlockAccessor methodsFor: 'accessing' stamp: 'lr 3/27/2005 10:02'!
writeBlock: aBlock
	writeBlock := aBlock! !

MAModelAccessor subclass: #MACascadeAccessor
	instanceVariableNames: 'accessor next'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Accessor'!

!MACascadeAccessor class methodsFor: 'instance creation' stamp: 'lr 3/27/2005 09:51'!
cascade: anArray
	^anArray allButLast reverse
		inject: anArray last
		into: [ :next :accessor | 
			self new
				next: next; 
				accessor: accessor;
				yourself ].! !

!MACascadeAccessor class methodsFor: 'testing' stamp: 'lr 3/30/2005 16:36'!
isAbstract
	^false! !

!MACascadeAccessor class methodsFor: 'instance creation' stamp: 'lr 3/27/2005 09:50'!
selectors: anArray
	^self cascade: (anArray collect: [ :each | 
		MASelectorAccessor selector: each ]).! !

!MACascadeAccessor methodsFor: 'accessing' stamp: 'lr 3/27/2005 09:38'!
accessor
	^accessor! !

!MACascadeAccessor methodsFor: 'accessing' stamp: 'lr 3/27/2005 09:42'!
accessor: anAccessor
	accessor := anAccessor! !

!MACascadeAccessor methodsFor: 'accessing' stamp: 'lr 3/27/2005 09:38'!
next
	^next! !

!MACascadeAccessor methodsFor: 'accessing' stamp: 'lr 3/27/2005 09:42'!
next: anAccessor
	next := anAccessor! !

!MACascadeAccessor methodsFor: 'copying' stamp: 'lr 3/30/2005 22:10'!
postCopy
	super postCopy.
	self accessor: self accessor copy.
	self next: self next copy.! !

!MACascadeAccessor methodsFor: 'model' stamp: 'lr 3/30/2005 10:54'!
read: aModel
	^self next read: (self accessor read: aModel).! !

!MACascadeAccessor methodsFor: 'initialize' stamp: 'lr 3/27/2005 09:53'!
setDescription: aDescription
	super setDescription: aDescription.
	self accessor setDescription: aDescription.
	self next setDescription: aDescription.! !

!MACascadeAccessor methodsFor: 'model' stamp: 'lr 3/28/2005 23:04'!
write: anObject to: aModel
	self next write: anObject to: (self accessor read: aModel).! !

MAModelAccessor subclass: #MAContainerAccessor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Accessor'!

!MAContainerAccessor class methodsFor: 'testing' stamp: 'lr 4/5/2005 13:10'!
isAbstract
	^false! !

!MAContainerAccessor methodsFor: 'testing' stamp: 'lr 4/6/2005 15:16'!
isContainer
	^true! !

!MAContainerAccessor methodsFor: 'model' stamp: 'lr 4/5/2005 13:15'!
read: aModel
	^aModel.! !

!MAContainerAccessor methodsFor: 'model' stamp: 'lr 4/5/2005 13:15'!
write: anObject to: aModel
	self error: 'Not supposed to write to ' , aModel asString , '.'.! !

!MAModelAccessor methodsFor: 'testing' stamp: 'lr 4/6/2005 15:16'!
isContainer
	^false! !

!MAModelAccessor methodsFor: 'testing' stamp: 'lr 3/31/2005 09:52'!
isNull
	^false! !

!MAModelAccessor methodsFor: 'model' stamp: 'lr 3/27/2005 09:55'!
read: aModel
	"Read from aModel using the description of the receiver."
	
	self subclassResponsibility.! !

!MAModelAccessor methodsFor: 'model' stamp: 'lr 3/27/2005 09:55'!
write: anObject to: aModel
	"Write to aModel using the description of the receiver and anObject as value."
	
	self subclassResponsibility.! !

MAModelAccessor subclass: #MANullAccessor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Accessor'!

!MANullAccessor class methodsFor: 'testing' stamp: 'lr 3/30/2005 16:36'!
isAbstract
	^false! !

!MANullAccessor methodsFor: 'testing' stamp: 'lr 3/31/2005 09:52'!
isNull
	^true! !

!MANullAccessor methodsFor: 'model' stamp: 'lr 4/5/2005 13:09'!
read: aModel
	self error: 'Not supposed to read from ' , aModel asString , '.'.! !

!MANullAccessor methodsFor: 'model' stamp: 'lr 4/5/2005 13:09'!
write: anObject to: aModel
	self error: 'Not supposed to write to ' , aModel asString , '.'.! !

MAModelAccessor subclass: #MASelectorAccessor
	instanceVariableNames: 'readSelector writeSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Accessor'!

!MASelectorAccessor class methodsFor: 'testing' stamp: 'lr 3/30/2005 16:36'!
isAbstract
	^false! !

!MASelectorAccessor class methodsFor: 'instance creation' stamp: 'lr 3/30/2005 14:39'!
read: aReadSelector write: aWriteSelector
	^self new
		readSelector: aReadSelector;
		writeSelector: aWriteSelector;
		yourself.! !

!MASelectorAccessor class methodsFor: 'instance creation' stamp: 'lr 3/30/2005 14:40'!
selector: aSelector
	^self new
		selector: aSelector;
		yourself.! !

!MASelectorAccessor methodsFor: 'model' stamp: 'lr 3/28/2005 23:03'!
read: aModel
	^aModel perform: self readSelector.! !

!MASelectorAccessor methodsFor: 'accessing' stamp: 'lr 3/30/2005 14:35'!
readSelector
	^readSelector! !

!MASelectorAccessor methodsFor: 'accessing' stamp: 'lr 3/30/2005 14:35'!
readSelector: aSelector
	readSelector := aSelector.! !

!MASelectorAccessor methodsFor: 'accessing-dynamic' stamp: 'lr 3/30/2005 14:40'!
selector
	^self readSelector.! !

!MASelectorAccessor methodsFor: 'accessing-dynamic' stamp: 'lr 3/30/2005 14:39'!
selector: aSelector
	self readSelector: aSelector asSymbol.
	self writeSelector: (aSelector copyWith: $:) asSymbol.! !

!MASelectorAccessor methodsFor: 'model' stamp: 'lr 3/28/2005 23:04'!
write: anObject to: aModel
	aModel perform: self writeSelector with: anObject.! !

!MASelectorAccessor methodsFor: 'accessing' stamp: 'lr 3/30/2005 14:35'!
writeSelector
	^writeSelector! !

!MASelectorAccessor methodsFor: 'accessing' stamp: 'lr 3/30/2005 14:35'!
writeSelector: aSelector
	writeSelector := aSelector.! !

MAAccessor subclass: #MAModelWrapper
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Accessor'!

MAModelWrapper subclass: #MACachedWrapper
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Accessor'!

!MACachedWrapper class methodsFor: 'testing' stamp: 'lr 3/30/2005 16:37'!
isAbstract
	^false! !

!MACachedWrapper methodsFor: 'private' stamp: 'lr 4/7/2005 22:40'!
commit: anObject
	super commit: anObject.
	self push: anObject.! !

!MACachedWrapper methodsFor: 'testing' stamp: 'lr 4/7/2005 23:10'!
hasChanged
	^self pull ~= self value.! !

!MACachedWrapper methodsFor: 'private' stamp: 'lr 4/7/2005 22:47'!
reset: anObject
	super reset: anObject.
	self value: (self pull ifNil: [ self description default ]).! !

!MACachedWrapper methodsFor: 'initialization' stamp: 'lr 3/31/2005 09:53'!
setModel: aModel
	super setModel: aModel.
	self reset.
	
! !

!MACachedWrapper methodsFor: 'accessing' stamp: 'lr 3/30/2005 15:21'!
value
	^value! !

!MACachedWrapper methodsFor: 'accessing' stamp: 'lr 3/30/2005 15:23'!
value: anObject
	value := anObject! !

MACachedWrapper subclass: #MACheckedWrapper
	instanceVariableNames: 'original'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Accessor'!

!MACheckedWrapper methodsFor: 'private' stamp: 'lr 4/7/2005 22:49'!
commit: anObject
	super commit: anObject.
	self original: self value.! !

!MACheckedWrapper methodsFor: 'testing' stamp: 'lr 4/7/2005 23:10'!
hasConflict
	^self hasChanged
		and: [ self pull ~= self original ].! !

!MACheckedWrapper methodsFor: 'accessing' stamp: 'lr 4/7/2005 18:38'!
original
	^original! !

!MACheckedWrapper methodsFor: 'accessing' stamp: 'lr 4/7/2005 18:38'!
original: anObject
	original := anObject! !

!MACheckedWrapper methodsFor: 'printing' stamp: 'lr 4/7/2005 23:00'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' original: '; print: self original.! !

!MACheckedWrapper methodsFor: 'private' stamp: 'lr 4/7/2005 22:49'!
reset: anObject
	super reset: anObject.
	self original: self pull.! !

!MACheckedWrapper methodsFor: 'private' stamp: 'lr 4/7/2005 23:27'!
validate: anObject
	super validate: anObject.
	self hasConflict ifTrue: [
		self reset: anObject.
		self errorConcurrent ].! !

!MAModelWrapper class methodsFor: 'instance creation' stamp: 'lr 3/30/2005 14:51'!
on: aDescription model: aModel
	^(self on: aDescription)
		setModel: aModel;
		yourself.! !

!MAModelWrapper methodsFor: 'accessing' stamp: 'lr 3/30/2005 22:08'!
accessor
	^self description accessor.! !

!MAModelWrapper methodsFor: 'actions' stamp: 'lr 4/7/2005 21:57'!
commit
	self description isReadonly
		ifTrue: [ self errorReadonly ].
	self commit: self value.! !

!MAModelWrapper methodsFor: 'private' stamp: 'lr 4/7/2005 22:01'!
commit: anObject
	"Primitive to commit anObject to the model. Do not call directly, use #commit instead."! !

!MAModelWrapper methodsFor: 'errors' stamp: 'lr 4/7/2005 22:27'!
errorConcurrent
	MAConcurrentError wrapper: self message: 'Concurrent modification in ' , self description asLabel.! !

!MAModelWrapper methodsFor: 'errors' stamp: 'lr 4/7/2005 22:27'!
errorReadonly
	MAReadonlyError wrapper: self message: self description asLabel , ' is readonly.'.! !

!MAModelWrapper methodsFor: 'errors' stamp: 'lr 4/7/2005 22:27'!
errorRequired
	MARequiredError wrapper: self message: self description asLabel , ' is required.'.! !

!MAModelWrapper methodsFor: 'errors' stamp: 'lr 4/7/2005 22:28'!
errorValidation
	MAValidationError wrapper: self message: self description asLabel , ' is invalid.'.! !

!MAModelWrapper methodsFor: 'accessing' stamp: 'lr 3/30/2005 15:16'!
model
	^model! !

!MAModelWrapper methodsFor: 'printing' stamp: 'lr 4/7/2005 22:59'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' value: '; print: self value.! !

!MAModelWrapper methodsFor: 'private-model' stamp: 'lr 4/7/2005 22:01'!
pull
	"Primitive to read from the model. Do not call directly, use #value instead."

	^self model readUsing: self description.! !

!MAModelWrapper methodsFor: 'private-model' stamp: 'lr 4/7/2005 22:01'!
push: anObject
	"Primitive to write to the model. Do not call directly, use #value: instead."

	self model write: anObject using: self description.! !

!MAModelWrapper methodsFor: 'actions' stamp: 'lr 4/7/2005 22:00'!
reset
	"Resets the value to the one of the model."
	
	self reset: self value.! !

!MAModelWrapper methodsFor: 'private' stamp: 'lr 4/7/2005 22:02'!
reset: anObject
	"Primitive to reset anObject. Do not call directly, use #reset instead."! !

!MAModelWrapper methodsFor: 'initialization' stamp: 'lr 3/30/2005 14:52'!
setModel: aModel
	model := aModel.! !

!MAModelWrapper methodsFor: 'actions' stamp: 'lr 4/7/2005 22:05'!
validate
	"Check if the value is valid within the model. In case of problems an exception is raised."

	self description isReadonly
		ifFalse: [ self validate: self value ].! !

!MAModelWrapper methodsFor: 'private' stamp: 'lr 4/7/2005 22:02'!
validate: anObject
	"Primitive to validate anObject. Do not call directly, use #validate instead."
	
	(self description isRequired and: [ anObject isNil ])
		ifTrue: [ self errorRequired ].
	(anObject isNil or: [ self description includes: anObject ])
		ifFalse: [ self errorValidation ].! !

!MAModelWrapper methodsFor: 'accessing-dynamic' stamp: 'lr 3/30/2005 15:20'!
value
	self subclassResponsability.! !

!MAModelWrapper methodsFor: 'accessing-dynamic' stamp: 'lr 4/6/2005 23:01'!
value: anObject
	self subclassResponsability.! !

MAModelWrapper subclass: #MAStraitWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Accessor'!

!MAStraitWrapper class methodsFor: 'testing' stamp: 'lr 3/30/2005 16:37'!
isAbstract
	^false! !

!MAStraitWrapper methodsFor: 'accessing' stamp: 'lr 4/7/2005 21:51'!
value
	^self pull ifNil: [ self description default ].! !

!MAStraitWrapper methodsFor: 'accessing' stamp: 'lr 4/7/2005 21:51'!
value: anObject
	self push: anObject.! !

Object subclass: #MABuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Builder'!

MABuilder class
	instanceVariableNames: 'default'!

!MABuilder class methodsFor: 'accessing' stamp: 'lr 3/10/2005 10:55'!
default
	default isNil
		ifTrue: [ default := self new ].
	^default.! !

!MABuilder methodsFor: 'actions' stamp: 'lr 4/5/2005 20:09'!
build: anObject
	| description |
	^anObject defaultContainer in: [ :container |
		anObject class allSelectors do: [ :each |
			(self isDescriptionSelector: each) ifTrue: [ 
				description := anObject perform: each.
				(description isKindOf: MADescription)
					ifTrue: [ container := container , description ] ] ].
		container ].! !

!MABuilder methodsFor: 'testing' stamp: 'lr 4/5/2005 21:04'!
isDescriptionSelector: aSelector
	^aSelector notNil
		and: [ aSelector isUnary ]
		and: [ aSelector ~= #description ] 
		and: [ aSelector beginsWith: #description ].! !

MABuilder subclass: #MACachedBuilder
	instanceVariableNames: 'cache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Builder'!

!MACachedBuilder methodsFor: 'actions' stamp: 'lr 4/5/2005 20:09'!
build: anObject
	^self cache
		at: anObject
		ifAbsentPut: [ super build: anObject ].! !

!MACachedBuilder methodsFor: 'accessing' stamp: 'lr 3/9/2005 22:46'!
cache
	^cache! !

!MACachedBuilder methodsFor: 'accessing' stamp: 'lr 3/9/2005 22:46'!
cache: aDictionary
	cache := aDictionary! !

!MACachedBuilder methodsFor: 'actions' stamp: 'lr 4/5/2005 20:42'!
flush
	self cache: IdentityDictionary new.! !

!MACachedBuilder methodsFor: 'initialization' stamp: 'lr 4/5/2005 19:56'!
initialize
	super initialize.
	self flush; register.! !

!MACachedBuilder methodsFor: 'events' stamp: 'lr 4/5/2005 21:04'!
modified: anEvent
	(self isDescriptionSelector: anEvent itemSelector) 
		ifTrue: [ self flush ].! !

!MACachedBuilder methodsFor: 'events' stamp: 'lr 4/5/2005 20:46'!
register
	SystemChangeNotifier uniqueInstance
		noMoreNotificationsFor: self;
		notify: self ofSystemChangesOfItem: #method change: #Added using: #modified:;
		notify: self ofSystemChangesOfItem: #method change: #Modified using: #modified:;
		notify: self ofSystemChangesOfItem: #method change: #Removed using: #modified:.! !

Object subclass: #MAComparator
	instanceVariableNames: ''
	classVariableNames: 'BeginsWith MagnitudeSorter BooleanSorter EqualTo GreaterThanOrEqualTo NotEqualTo GreaterThan LessThanOrEqualTo StringSorter LessThan Match EndsWith NullSorter'
	poolDictionaries: ''
	category: 'Magritte-Core-Comparator'!

!MAComparator class methodsFor: 'accessing-string' stamp: 'lr 3/19/2005 21:12'!
beginsWith
	^BeginsWith! !

!MAComparator class methodsFor: 'accessing-sorting' stamp: 'lr 3/24/2005 09:22'!
booleanSorter
	^BooleanSorter! !

!MAComparator class methodsFor: 'accessing-string' stamp: 'lr 3/19/2005 21:12'!
endsWith
	^EndsWith! !

!MAComparator class methodsFor: 'accessing-equality' stamp: 'lr 3/19/2005 21:12'!
equalTo 
	^EqualTo! !

!MAComparator class methodsFor: 'accessing' stamp: 'lr 3/19/2005 21:45'!
equalityComparators
	^Array with: self equalTo with: self notEqualTo.! !

!MAComparator class methodsFor: 'accessing-magnitude' stamp: 'lr 3/19/2005 21:13'!
greaterThan	
	^GreaterThan! !

!MAComparator class methodsFor: 'accessing-magnitude' stamp: 'lr 3/19/2005 21:18'!
greaterThanOrEqualTo
	^GreaterThanOrEqualTo! !

!MAComparator class methodsFor: 'class initialization' stamp: 'lr 3/31/2005 07:31'!
initialize

	" equality comparators "
	EqualTo := MAGenericComparator label: 'is' selector: #=.
	NotEqualTo := MAGenericComparator label: 'is not' selector: #~=.
	
	" magnitude comparators "
	LessThan := MAGenericComparator label: 'is less than' selector: #<.
	LessThanOrEqualTo := MAGenericComparator label: 'is less than or equal to' selector: #<=.
	GreaterThan := MAGenericComparator label: 'is greater than' selector: #>.
	GreaterThanOrEqualTo := MAGenericComparator label: 'is greater than or equal to' selector: #>=.
	
	" string comparators "
	BeginsWith := MAGenericComparator label: 'starts with' selector: #beginsWith:.
	EndsWith := MAGenericComparator label: 'ends with' selector: #endsWith:.
	Match := MAMatchComparator new.
	
	" sorters "
	NullSorter := MASortingComparator block: [ :a :b | true ].
	MagnitudeSorter := MASortingComparator block: [ :a :b | a <= b ].
	StringSorter := MASortingComparator block: [ :a :b | (a compare: b) <= 2 ].
	BooleanSorter := MASortingComparator block: [ :a :b | a not or: [ b ] ].! !

!MAComparator class methodsFor: 'accessing-magnitude' stamp: 'lr 3/19/2005 21:13'!
lessThan
	^LessThan! !

!MAComparator class methodsFor: 'accessing-magnitude' stamp: 'lr 3/19/2005 21:13'!
lessThanOrEqualTo
	^LessThanOrEqualTo! !

!MAComparator class methodsFor: 'accessing' stamp: 'lr 3/19/2005 21:46'!
magnitudeComparators
	^Array with: self lessThan with: self lessThanOrEqualTo with: self greaterThan with: self greaterThanOrEqualTo.! !

!MAComparator class methodsFor: 'accessing-sorting' stamp: 'lr 3/24/2005 09:22'!
magnitudeSorter
	^MagnitudeSorter! !

!MAComparator class methodsFor: 'accessing-string' stamp: 'lr 3/19/2005 21:53'!
match
	^Match! !

!MAComparator class methodsFor: 'accessing-equality' stamp: 'lr 3/19/2005 21:13'!
notEqualTo
	^NotEqualTo! !

!MAComparator class methodsFor: 'accessing-sorting' stamp: 'lr 3/24/2005 09:22'!
nullSorter
	^NullSorter! !

!MAComparator class methodsFor: 'accessing' stamp: 'lr 3/19/2005 21:53'!
stringComparators
	^Array with: self beginsWith with: self endsWith with: self match.! !

!MAComparator class methodsFor: 'accessing-sorting' stamp: 'lr 3/24/2005 09:22'!
stringSorter
	^StringSorter! !

!MAComparator methodsFor: 'private' stamp: 'lr 3/17/2005 15:30'!
compare: aLeftObject to: aRightObject
	self subclassResponsibility.! !

!MAComparator methodsFor: 'comparing' stamp: 'lr 3/17/2005 15:38'!
compare: aLeftObject with: aRightObject
	^[ self compare: aLeftObject to: aRightObject ]
		ifError: [ false ].! !

!MAComparator methodsFor: 'comparing' stamp: 'lr 4/2/2005 21:20'!
compare: aLeftObject with: aRightObject description: aDescription
	^(aDescription comparators includes: self) and: [
		self
			compare: (aDescription accessor read: aRightObject)
			with: (aDescription parseString: aLeftObject) ].! !

!MAComparator methodsFor: 'accessing' stamp: 'lr 3/24/2005 09:56'!
selector
	^nil! !

MAComparator subclass: #MAGenericComparator
	instanceVariableNames: 'label selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Comparator'!

!MAGenericComparator class methodsFor: 'instance creation' stamp: 'lr 3/19/2005 21:43'!
label: aString selector: aSelector
	^self new
		setLabel: aString;
		setSelector: aSelector;
		yourself.! !

!MAGenericComparator methodsFor: 'converting' stamp: 'lr 3/24/2005 00:54'!
asLabel
	^label! !

!MAGenericComparator methodsFor: 'private' stamp: 'lr 3/19/2005 21:42'!
compare: aLeftObject to: aRightObject
	^aLeftObject perform: selector with: aRightObject.! !

!MAGenericComparator methodsFor: 'accessing' stamp: 'lr 3/24/2005 09:56'!
selector	
	^selector! !

!MAGenericComparator methodsFor: 'initialization' stamp: 'lr 3/24/2005 00:54'!
setLabel: aString
	label := aString! !

!MAGenericComparator methodsFor: 'initialization' stamp: 'lr 3/19/2005 21:41'!
setSelector: aSymbol
	selector := aSymbol! !

MAComparator subclass: #MAMatchComparator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Comparator'!

!MAMatchComparator methodsFor: 'converting' stamp: 'lr 3/19/2005 22:27'!
asLabel
	^ 'match'! !

!MAMatchComparator methodsFor: 'private' stamp: 'lr 3/20/2005 01:13'!
compare: aLeftObject to: aRightObject
	^(self patternFor: aRightObject) match: aLeftObject.! !

!MAMatchComparator methodsFor: 'private' stamp: 'lr 3/21/2005 20:56'!
includesJoker: aString
	^aString includesAnyOf: '*#'.! !

!MAMatchComparator methodsFor: 'private' stamp: 'lr 3/19/2005 22:31'!
patternFor: aString
	^(self includesJoker: aString)
		ifTrue: [ aString ]
		ifFalse: [ '*' , aString , '*' ].! !

!MAMatchComparator methodsFor: 'accessing' stamp: 'lr 3/24/2005 09:56'!
selector
	^ #match:! !

MAComparator subclass: #MASortingComparator
	instanceVariableNames: 'block'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Comparator'!

!MASortingComparator class methodsFor: 'instance creation' stamp: 'lr 3/24/2005 00:55'!
block: aBlock
	^self new
		setBlock: aBlock;
		yourself.! !

!MASortingComparator methodsFor: 'converting' stamp: 'lr 3/24/2005 00:55'!
asLabel
	^ 'sorts before'! !

!MASortingComparator methodsFor: 'private' stamp: 'lr 3/24/2005 09:45'!
compare: aLeftObject to: aRightObject
	^aLeftObject isNil 
		or: [ aRightObject notNil
		and: [ block value: aLeftObject value: aRightObject ] ].! !

!MASortingComparator methodsFor: 'initialization' stamp: 'lr 3/24/2005 00:50'!
setBlock: aBlock
	block := aBlock! !

Object subclass: #MADescription
	instanceVariableNames: 'hash accessor properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

MADescription subclass: #MAContainer
	instanceVariableNames: 'children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MAContainer class methodsFor: 'accessing-defaults' stamp: 'lr 4/6/2005 20:09'!
defaultAccessor
	^MAContainerAccessor new.! !

!MAContainer class methodsFor: 'accessing-defaults' stamp: 'lr 3/24/2005 00:15'!
defaultCollection
	^OrderedCollection new.! !

!MAContainer class methodsFor: 'testing' stamp: 'lr 3/19/2005 10:29'!
isAbstract
	^false! !

!MAContainer class methodsFor: 'instance creation' stamp: 'lr 3/24/2005 09:57'!
new
	^super new
		setChildren: self defaultCollection;
		yourself.! !

!MAContainer class methodsFor: 'instance creation' stamp: 'lr 3/24/2005 00:07'!
with: aDescription
	^self new
		add: aDescription;
		yourself.! !

!MAContainer class methodsFor: 'instance creation' stamp: 'lr 3/24/2005 00:08'!
withAll: aCollection
	^self new
		addAll: aCollection;
		yourself.! !

!MAContainer methodsFor: 'adding' stamp: 'lr 3/24/2005 00:09'!
add: aDescription
	self children add: aDescription.! !

!MAContainer methodsFor: 'adding' stamp: 'lr 3/9/2005 22:52'!
addAll: aCollection
	aCollection do: [ :each | self add: each ].! !

!MAContainer methodsFor: 'converting' stamp: 'lr 3/24/2005 12:19'!
asContainer
	^self! !

!MAContainer methodsFor: 'accessing' stamp: 'lr 3/10/2005 10:51'!
children
	^children! !

!MAContainer methodsFor: 'enumerating' stamp: 'lr 3/24/2005 12:06'!
collect: aBlock
	^self copy 
		setChildren: (self children collect: aBlock);
		yourself.! !

!MAContainer methodsFor: 'copying' stamp: 'lr 3/24/2005 12:08'!
copyFrom: aStartIndex to: anEndIndex
	^self copy 
		setChildren: (self children
			copyFrom: aStartIndex 
			to: anEndIndex);
		yourself.! !

!MAContainer methodsFor: 'enumerating' stamp: 'lr 3/24/2005 17:31'!
detect: aBlock 
	^self children detect: aBlock.! !

!MAContainer methodsFor: 'enumerating' stamp: 'lr 3/24/2005 10:42'!
detect: aBlock ifNone: anExceptionBlock 
	^self children detect: aBlock ifNone: anExceptionBlock.! !

!MAContainer methodsFor: 'enumerating' stamp: 'lr 3/10/2005 10:52'!
do: aBlock
	self children do: aBlock.! !

!MAContainer methodsFor: 'enumerating' stamp: 'lr 3/24/2005 00:19'!
do: aBlock separatedBy: aSeparatorBlock
	self children do: aBlock separatedBy: aSeparatorBlock.! !

!MAContainer methodsFor: 'testing' stamp: 'lr 4/4/2005 13:53'!
hasChildren
	^self notEmpty.! !

!MAContainer methodsFor: 'testing' stamp: 'lr 3/21/2005 20:07'!
includes: aDescription
	^self children includes: aDescription.! !

!MAContainer methodsFor: 'enumerating' stamp: 'lr 3/24/2005 00:19'!
inject: anObject into: aBlock 
	^self children inject: anObject into: aBlock.! !

!MAContainer methodsFor: 'testing' stamp: 'lr 4/6/2005 15:17'!
isContainer	
	^true! !

!MAContainer methodsFor: 'testing' stamp: 'lr 3/22/2005 16:32'!
isEmpty
	^self children isEmpty.! !

!MAContainer methodsFor: 'moving' stamp: 'lr 4/6/2005 20:15'!
moveDown: aDescription
	| index |
	index := self children 
		indexOf: aDescription 
		ifAbsent: [ ^self ].
	self children swap: index with: (index = self size
		ifFalse:[ index + 1 ]
		ifTrue: [ 1 ]).! !

!MAContainer methodsFor: 'moving' stamp: 'lr 4/6/2005 20:15'!
moveUp: aDescription
	| index |
	index := self children 
		indexOf: aDescription 
		ifAbsent: [ ^self ].
	self children swap: index with: (index = 1
		ifFalse:[ index - 1 ]
		ifTrue: [ self size ]).! !

!MAContainer methodsFor: 'testing' stamp: 'lr 3/22/2005 16:39'!
notEmpty
	^self children notEmpty.! !

!MAContainer methodsFor: 'copying' stamp: 'lr 3/24/2005 12:36'!
postCopy
	super postCopy.
	self setChildren: self children copy.! !

!MAContainer methodsFor: 'enumerating' stamp: 'lr 3/24/2005 12:06'!
reject: aBlock
	^self copy 
		setChildren: (self children reject: aBlock);
		yourself.! !

!MAContainer methodsFor: 'removing' stamp: 'lr 3/24/2005 00:09'!
remove: aDescription
	self children remove: aDescription ifAbsent: [ ].! !

!MAContainer methodsFor: 'removing' stamp: 'lr 3/24/2005 10:08'!
removeAll
	children := self class defaultCollection.! !

!MAContainer methodsFor: 'enumerating' stamp: 'lr 3/24/2005 12:06'!
select: aBlock
	^self copy 
		setChildren: (self children select: aBlock);
		yourself.! !

!MAContainer methodsFor: 'initialization' stamp: 'lr 3/24/2005 00:13'!
setChildren: aCollection
	children := aCollection! !

!MAContainer methodsFor: 'accessing' stamp: 'lr 3/24/2005 00:11'!
size
	^self children size.! !

!MAContainer methodsFor: 'enumerating' stamp: 'lr 3/24/2005 15:31'!
withIndexDo: aBlock
	self children withIndexDo: aBlock.! !

MAContainer subclass: #MAPriorityContainer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MAPriorityContainer class methodsFor: 'accessing-defaults' stamp: 'lr 4/6/2005 20:01'!
defaultCollection
	^SortedCollection new.! !

!MAPriorityContainer methodsFor: 'moving' stamp: 'lr 4/6/2005 22:15'!
moveDown: aDescription
	aDescription priority: aDescription priority - 1.
	self resort.! !

!MAPriorityContainer methodsFor: 'moving' stamp: 'lr 4/6/2005 22:15'!
moveUp: aDescription
	aDescription priority: aDescription priority + 1.
	self resort.! !

!MAPriorityContainer methodsFor: 'actions' stamp: 'lr 4/6/2005 22:16'!
resort
	self setChildren: self children copy.! !

MAContainer subclass: #MAReportContainer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MAReportContainer class methodsFor: 'accessing-defaults-table' stamp: 'lr 3/23/2005 23:47'!
defaultCaption
	^nil! !

!MAReportContainer class methodsFor: 'accessing-defaults-table' stamp: 'lr 3/23/2005 23:47'!
defaultEmpty
	^'The report is empty.'! !

!MAReportContainer class methodsFor: 'accessing-defaults-batch' stamp: 'lr 3/23/2005 23:51'!
defaultPageSize
	^10! !

!MAReportContainer class methodsFor: 'accessing-defaults' stamp: 'lr 3/23/2005 23:57'!
defaultShowBatch
	^true! !

!MAReportContainer class methodsFor: 'accessing-defaults' stamp: 'lr 3/23/2005 23:57'!
defaultShowFooter
	^true! !

!MAReportContainer class methodsFor: 'accessing-defaults' stamp: 'lr 3/23/2005 23:57'!
defaultShowHeader
	^true! !

!MAReportContainer class methodsFor: 'accessing-defaults-table' stamp: 'lr 3/23/2005 23:47'!
defaultSummary
	^nil! !

!MAReportContainer class methodsFor: 'accessing-description-table' stamp: 'lr 3/28/2005 12:09'!
descriptionCaption
	^MAStringDescription selector: #caption label: 'Caption' priority: 1000 default: self defaultCaption.! !

!MAReportContainer class methodsFor: 'accessing-description-table' stamp: 'lr 3/28/2005 12:09'!
descriptionEmpty
	^MAStringDescription selector: #empty label: 'Empty' priority: 1200 default: self defaultEmpty.! !

!MAReportContainer class methodsFor: 'accessing-description-batch' stamp: 'lr 3/28/2005 12:09'!
descriptionPageSize
	^MANumberDescription selector: #pageSize label: 'Page Size' priority: 2000 default: self defaultPageSize.! !

!MAReportContainer class methodsFor: 'accessing-description' stamp: 'lr 3/28/2005 12:10'!
descriptionShowBatch
	^MABooleanDescription selector: #showBatch label: 'Show Batch' priority: 3200 default: self defaultShowBatch.! !

!MAReportContainer class methodsFor: 'accessing-description' stamp: 'lr 3/28/2005 12:10'!
descriptionShowFooter
	^MABooleanDescription selector: #showFooter label: 'Show Footer' priority: 3100 default: self defaultShowFooter.! !

!MAReportContainer class methodsFor: 'accessing-description' stamp: 'lr 3/28/2005 12:10'!
descriptionShowHeader
	^MABooleanDescription selector: #showHeader label: 'Show Header' priority: 3000 default: self defaultShowHeader.! !

!MAReportContainer class methodsFor: 'accessing-description-table' stamp: 'lr 3/28/2005 12:10'!
descriptionSummary
	^MAStringDescription selector: #summary label: 'Summary' priority: 1100 default: self defaultSummary.! !

!MAReportContainer methodsFor: 'accessing-table' stamp: 'lr 3/23/2005 23:42'!
caption
	^self propertyAt: #caption ifAbsent: [ self class defaultCaption ].! !

!MAReportContainer methodsFor: 'accessing-table' stamp: 'lr 3/23/2005 23:42'!
caption: aString
	self propertyAt: #caption put: aString.! !

!MAReportContainer methodsFor: 'accessing-table' stamp: 'lr 3/23/2005 23:45'!
empty
	^self propertyAt: #empty ifAbsent: [ self class defaultEmpty ].! !

!MAReportContainer methodsFor: 'accessing-table' stamp: 'lr 3/23/2005 23:45'!
empty: aString
	self propertyAt: #empty put: aString.! !

!MAReportContainer methodsFor: 'accessing-batch' stamp: 'lr 3/23/2005 23:51'!
pageSize
	^self propertyAt: #pageSize ifAbsent: [ self class defaultPageSize ].! !

!MAReportContainer methodsFor: 'accessing-batch' stamp: 'lr 3/23/2005 23:50'!
pageSize: aNumber
	self propertyAt: #pageSize put: aNumber.! !

!MAReportContainer methodsFor: 'accessing' stamp: 'lr 3/23/2005 23:54'!
showBatch
	^self propertyAt: #showBatch ifAbsent: [ self class defaultShowBatch ].! !

!MAReportContainer methodsFor: 'accessing' stamp: 'lr 3/23/2005 23:54'!
showBatch: aBoolean
	self propertyAt: #showBatch put: aBoolean.! !

!MAReportContainer methodsFor: 'accessing' stamp: 'lr 3/23/2005 23:54'!
showFooter
	^self propertyAt: #showFooter ifAbsent: [ self class defaultShowFooter ].! !

!MAReportContainer methodsFor: 'accessing' stamp: 'lr 3/23/2005 23:53'!
showFooter: aBoolean
	self propertyAt: #showFooter put: aBoolean.! !

!MAReportContainer methodsFor: 'accessing' stamp: 'lr 3/23/2005 23:53'!
showHeader
	^self propertyAt: #showHeader ifAbsent: [ self class defaultShowHeader ].! !

!MAReportContainer methodsFor: 'accessing' stamp: 'lr 3/23/2005 23:53'!
showHeader: aBoolean
	self propertyAt: #showHeader put: aBoolean.! !

!MAReportContainer methodsFor: 'accessing-table' stamp: 'lr 3/23/2005 23:44'!
summary
	^self propertyAt: #summary ifAbsent: [ self class defaultSummary ].! !

!MAReportContainer methodsFor: 'accessing-table' stamp: 'lr 3/23/2005 23:44'!
summary: aString
	self propertyAt: #summary put: aString.! !

!MADescription class methodsFor: 'converting' stamp: 'lr 4/4/2005 18:42'!
asLabel
	^super asLabel allButFirst: 2.! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 4/6/2005 20:09'!
defaultAccessor
	^MANullAccessor new.! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/23/2005 07:21'!
defaultComment
	^nil! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/9/2005 18:33'!
defaultLabel
	^nil! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/19/2005 12:30'!
defaultPersistent
	^true! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/10/2005 10:27'!
defaultPriority
	^0! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/10/2005 11:23'!
defaultReadonly
	^false! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/11/2005 20:39'!
defaultRequired
	^false! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/10/2005 10:28'!
defaultVisible
	^true! !

!MADescription class methodsFor: 'accessing-description' stamp: 'lr 3/27/2005 10:36'!
descriptionComment
	^MATextDescription selector: #comment label: 'Comment' priority: 110 default: self defaultComment.! !

!MADescription class methodsFor: 'accessing-description' stamp: 'lr 3/27/2005 10:36'!
descriptionLabel
	^MAStringDescription selector: #label label: 'Label' priority: 100 default: self defaultLabel.! !

!MADescription class methodsFor: 'accessing-description' stamp: 'lr 3/27/2005 10:35'!
descriptionPersistent
	^MABooleanDescription selector: #persistent label: 'Persistent' priority: 330 default: self defaultPersistent.! !

!MADescription class methodsFor: 'accessing-description' stamp: 'lr 3/27/2005 10:35'!
descriptionPriority
	^MANumberDescription selector: #priority label: 'Priority' priority: 120 default: self defaultPriority.! !

!MADescription class methodsFor: 'accessing-description' stamp: 'lr 3/27/2005 10:36'!
descriptionReadonly
	^MABooleanDescription selector: #readonly label: 'Readonly' priority: 300 default: self defaultReadonly.! !

!MADescription class methodsFor: 'accessing-description' stamp: 'lr 3/28/2005 12:11'!
descriptionRequired
	^MABooleanDescription selector: #required label: 'Required' priority: 320 default: self defaultRequired.! !

!MADescription class methodsFor: 'accessing-description' stamp: 'lr 3/28/2005 12:11'!
descriptionVisible
	^MABooleanDescription selector: #visible label: 'Visible' priority: 310 default: self defaultVisible.! !

!MADescription class methodsFor: 'testing' stamp: 'lr 3/28/2005 19:03'!
isAbstract
	^true! !

!MADescription class methodsFor: 'instance creation' stamp: 'lr 3/28/2005 19:03'!
new
	"Create a new instance of the receiving class and checks if it is concrete."

	self isAbstract
		ifTrue: [ self error: self name , ' is abstract.' ].
	^super new.! !

!MADescription methodsFor: 'operators' stamp: 'lr 3/24/2005 12:31'!
, aDescription
	"Merge the receiver and aDescription to one composed description"

	^self asContainer copy
		addAll: aDescription asContainer;
		yourself.! !

!MADescription methodsFor: 'operators' stamp: 'lr 4/6/2005 20:04'!
<= anObject
	"Answer whether the receiver should precede anObject in a priority container."
	
	^self priority <= anObject priority.! !

!MADescription methodsFor: 'comparing' stamp: 'lr 4/6/2005 20:06'!
= anObject
	"Compare the receiver with the argument and answer with true if the receiver is equal to the argument."
	
	^super = anObject or: [ self hasSameHashAs: anObject ].! !

!MADescription methodsFor: 'accessing' stamp: 'lr 4/6/2005 20:08'!
accessor
	accessor isNil
		ifTrue: [ self accessor: self class defaultAccessor ].
	^accessor.! !

!MADescription methodsFor: 'accessing' stamp: 'lr 3/31/2005 09:44'!
accessor: anAccessor	
	accessor := anAccessor.
	accessor isNil
		ifFalse: [ accessor setDescription: self ].! !

!MADescription methodsFor: 'converting' stamp: 'lr 3/24/2005 00:04'!
asContainer
	self subclassResponsibility.! !

!MADescription methodsFor: 'converting' stamp: 'lr 3/27/2005 10:52'!
asLabel
	^self label ifNil: [ super asLabel ].! !

!MADescription methodsFor: 'actions' stamp: 'lr 3/14/2005 18:12'!
beEphemeral
	self persistent: false.! !

!MADescription methodsFor: 'actions' stamp: 'lr 3/10/2005 10:14'!
beHidden
	self visible: false.! !

!MADescription methodsFor: 'actions' stamp: 'lr 3/11/2005 20:31'!
beOptional
	self required: false.! !

!MADescription methodsFor: 'actions' stamp: 'lr 3/14/2005 18:12'!
bePersistent
	self persistent: true.! !

!MADescription methodsFor: 'actions' stamp: 'lr 3/10/2005 10:14'!
beReadonly
	self readonly: true.! !

!MADescription methodsFor: 'actions' stamp: 'lr 3/11/2005 20:25'!
beRequired
	self required: true.! !

!MADescription methodsFor: 'actions' stamp: 'lr 3/10/2005 10:14'!
beVisible
	self visible: true.! !

!MADescription methodsFor: 'actions' stamp: 'lr 3/10/2005 10:14'!
beWriteable
	self readonly: false.! !

!MADescription methodsFor: 'accessing-settings' stamp: 'lr 3/23/2005 23:43'!
comment	
	^self propertyAt: #comment ifAbsent: [ self class defaultComment ].! !

!MADescription methodsFor: 'accessing-settings' stamp: 'lr 3/27/2005 11:07'!
comment: aString
	self propertyAt: #comment put: aString.! !

!MADescription methodsFor: 'private' stamp: 'lr 4/6/2005 14:13'!
createHash
	hash := SmallInteger maxVal atRandom.! !

!MADescription methodsFor: 'testing' stamp: 'lr 4/4/2005 13:53'!
hasChildren
	^false! !

!MADescription methodsFor: 'testing' stamp: 'lr 3/23/2005 07:28'!
hasComment
	^(self propertyAt: #comment ifAbsent: [ ^false ])
		isEmptyOrNil not.! !

!MADescription methodsFor: 'testing' stamp: 'lr 3/27/2005 12:01'!
hasLabel
	^(self propertyAt: #label ifAbsent: [ ^false ])
		isEmptyOrNil not.! !

!MADescription methodsFor: 'private' stamp: 'lr 4/6/2005 14:14'!
hasSameHashAs: anObject
	^self class = anObject class
		and: [ self hash = anObject hash ].! !

!MADescription methodsFor: 'comparing' stamp: 'lr 4/6/2005 14:13'!
hash
	^hash! !

!MADescription methodsFor: 'initialization' stamp: 'lr 4/6/2005 14:14'!
initialize
	super initialize.
	self createHash.! !

!MADescription methodsFor: 'testing' stamp: 'lr 4/6/2005 15:17'!
isContainer	
	^false! !

!MADescription methodsFor: 'testing' stamp: 'lr 3/14/2005 18:11'!
isPersistent
	^self persistent.! !

!MADescription methodsFor: 'testing' stamp: 'lr 3/10/2005 10:14'!
isReadonly
	^self readonly.! !

!MADescription methodsFor: 'testing' stamp: 'lr 3/11/2005 20:31'!
isRequired
	^self required.! !

!MADescription methodsFor: 'testing' stamp: 'lr 3/10/2005 10:14'!
isVisible
	^self visible.! !

!MADescription methodsFor: 'private' stamp: 'lr 4/6/2005 23:46'!
key
	^[ self accessor selector ]
		on: Error
		do: [ :err | nil ].! !

!MADescription methodsFor: 'accessing-settings' stamp: 'lr 3/27/2005 11:07'!
label	
	^self propertyAt: #label ifAbsent: [ self class defaultLabel ].! !

!MADescription methodsFor: 'accessing-settings' stamp: 'lr 3/27/2005 11:07'!
label: aString
	self propertyAt: #label put: aString.! !

!MADescription methodsFor: 'accessing-settings' stamp: 'lr 3/23/2005 23:43'!
persistent	
	^self propertyAt: #persistent ifAbsent: [ self class defaultPersistent ].! !

!MADescription methodsFor: 'accessing-settings' stamp: 'lr 3/14/2005 18:11'!
persistent: aBoolean
	self propertyAt: #persistent put: aBoolean.! !

!MADescription methodsFor: 'copying' stamp: 'lr 4/6/2005 14:14'!
postCopy
	super postCopy.
	self createHash.
	self properties: self properties copy.
	self accessor: self accessor copy.! !

!MADescription methodsFor: 'printing' stamp: 'lr 4/6/2005 18:59'!
printOn: aStream
	super printOn: aStream.
	aStream nextPut: $[; print: self hash; nextPut: $].
	aStream nextPutAll: ' label: '; print: self label.! !

!MADescription methodsFor: 'accessing-settings' stamp: 'lr 3/23/2005 23:43'!
priority
	^self propertyAt: #priority ifAbsent: [ self class defaultPriority ].! !

!MADescription methodsFor: 'accessing-settings' stamp: 'lr 3/17/2005 15:17'!
priority: aNumber
	self propertyAt: #priority put: aNumber.! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 3/28/2005 19:02'!
properties
	properties isNil
		ifTrue: [ properties := Dictionary new ].
	^properties.! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 3/31/2005 09:41'!
properties: aDictionary
	properties := aDictionary! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 3/28/2005 19:02'!
propertyAt: aKey
	^self properties at: aKey.! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 3/28/2005 19:02'!
propertyAt: aKey ifAbsent: aBlock
	^self properties at: aKey ifAbsent: aBlock.! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 3/28/2005 19:02'!
propertyAt: aKey ifAbsentPut: aBlock
	^self properties at: aKey ifAbsentPut: aBlock.! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 3/28/2005 19:02'!
propertyAt: aKey put: aValue
	^self properties at: aKey put: aValue.! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 3/28/2005 19:02'!
propertyIncludes: aKey
	^self properties includesKey: aKey.! !

!MADescription methodsFor: 'accessing-settings' stamp: 'lr 3/23/2005 23:43'!
readonly	
	^self propertyAt: #readonly ifAbsent: [ self class defaultReadonly ].! !

!MADescription methodsFor: 'accessing-settings' stamp: 'lr 3/10/2005 10:11'!
readonly: aBoolean	
	self propertyAt: #readonly put: aBoolean.! !

!MADescription methodsFor: 'accessing-settings' stamp: 'lr 3/23/2005 23:43'!
required	
	^self propertyAt: #required 	ifAbsent: [ self class defaultRequired ].! !

!MADescription methodsFor: 'accessing-settings' stamp: 'lr 3/11/2005 20:24'!
required: aBoolean	
	self propertyAt: #required put: aBoolean.! !

!MADescription methodsFor: 'accessing-settings' stamp: 'lr 3/23/2005 23:43'!
visible	
	^self propertyAt: #visible ifAbsent: [ self class defaultVisible ].! !

!MADescription methodsFor: 'accessing-settings' stamp: 'lr 3/10/2005 10:11'!
visible: aBoolean
	self propertyAt: #visible put: aBoolean.! !

MADescription subclass: #MAElementDescription
	instanceVariableNames: 'default'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

MAElementDescription subclass: #MABinaryDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MABinaryDescription class methodsFor: 'converting' stamp: 'lr 4/4/2005 18:34'!
asLabel
	^'Upload'! !

!MABinaryDescription class methodsFor: 'testing' stamp: 'lr 3/19/2005 10:29'!
isAbstract
	^false! !

!MABinaryDescription methodsFor: 'accessing' stamp: 'lr 3/30/2005 07:30'!
kind
	^ByteArray! !

!MABinaryDescription methodsFor: 'converting' stamp: 'lr 3/15/2005 21:41'!
parseString: aString
	^self parseString: aString protected: [ ByteArray withAll: aString ].! !

MAElementDescription subclass: #MABooleanDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MABooleanDescription class methodsFor: 'converting' stamp: 'lr 4/4/2005 18:34'!
asLabel
	^'Check-Box'! !

!MABooleanDescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/10/2005 11:48'!
defaultDefault
	^false! !

!MABooleanDescription class methodsFor: 'testing' stamp: 'lr 3/19/2005 10:29'!
isAbstract
	^false! !

!MABooleanDescription methodsFor: 'private' stamp: 'lr 3/11/2005 21:40'!
falseStrings
	^ #( 'false' 'f' 'no' 'n' '0' 'off' )! !

!MABooleanDescription methodsFor: 'accessing' stamp: 'lr 3/23/2005 14:16'!
kind
	^Boolean! !

!MABooleanDescription methodsFor: 'converting' stamp: 'lr 3/14/2005 16:10'!
parseString: aString
	^self parseString: aString protected: [
		(self trueStrings includes: aString)
			ifTrue: [ ^true ].
		(self falseStrings includes: aString)
			ifTrue: [ ^false ].
		aString ].! !

!MABooleanDescription methodsFor: 'private' stamp: 'lr 3/11/2005 21:40'!
trueStrings
	^ #( 'true' 't' 'yes' 'y' '1' 'on' )! !

!MAElementDescription class methodsFor: 'instance-creation' stamp: 'lr 3/27/2005 10:19'!
accessor: anAccessor
	^self accessor: anAccessor label: self defaultLabel.! !

!MAElementDescription class methodsFor: 'instance-creation' stamp: 'lr 3/27/2005 10:19'!
accessor: anAccessor label: aString
	^self accessor: anAccessor label: aString priority: self defaultPriority.! !

!MAElementDescription class methodsFor: 'instance-creation' stamp: 'lr 4/6/2005 22:23'!
accessor: anAccessor label: aString priority: aNumber
	^self accessor: anAccessor label: aString priority: aNumber default: self defaultDefault.! !

!MAElementDescription class methodsFor: 'instance-creation' stamp: 'lr 3/27/2005 10:20'!
accessor: anAccessor label: aString priority: aNumber default: anObject
	^self new
		accessor: anAccessor;
		label: aString;
		priority: aNumber;
		default: anObject;
		yourself.! !

!MAElementDescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/14/2005 11:48'!
defaultDefault
	^nil! !

!MAElementDescription class methodsFor: 'accessing-description' stamp: 'lr 3/27/2005 10:37'!
descriptionDefault
	^self isAbstract 
		ifFalse: [ self selector: #default label: 'Default' priority: 200 default: self defaultDefault ].! !

!MAElementDescription class methodsFor: 'instance-creation-block' stamp: 'lr 4/6/2005 22:28'!
read: aReadBlock write: aWriteBlock
	^self accessor: (MABlockAccessor read: aReadBlock write: aWriteBlock).! !

!MAElementDescription class methodsFor: 'instance-creation-block' stamp: 'lr 4/6/2005 22:28'!
read: aReadBlock write: aWriteBlock label: aString
	^self accessor: (MABlockAccessor read: aReadBlock write: aWriteBlock) label: aString.! !

!MAElementDescription class methodsFor: 'instance-creation-block' stamp: 'lr 4/6/2005 22:28'!
read: aReadBlock write: aWriteBlock label: aString priority: aNumber
	^self accessor: (MABlockAccessor read: aReadBlock write: aWriteBlock) label: aString priority: aNumber.! !

!MAElementDescription class methodsFor: 'instance-creation-block' stamp: 'lr 4/6/2005 22:28'!
read: aReadBlock write: aWriteBlock label: aString priority: aNumber default: anObject
	^self accessor: (MABlockAccessor read: aReadBlock write: aWriteBlock) label: aString priority: aNumber default: anObject.! !

!MAElementDescription class methodsFor: 'instance-creation-selector' stamp: 'lr 3/27/2005 10:26'!
selector: aSelector
	^self accessor: (MASelectorAccessor selector: aSelector).! !

!MAElementDescription class methodsFor: 'instance-creation-selector' stamp: 'lr 3/27/2005 10:26'!
selector: aSelector label: aString
	^self accessor: (MASelectorAccessor selector: aSelector) label: aString.! !

!MAElementDescription class methodsFor: 'instance-creation-selector' stamp: 'lr 3/27/2005 10:27'!
selector: aSelector label: aString priority: aNumber
	^self accessor: (MASelectorAccessor selector: aSelector) label: aString priority: aNumber.! !

!MAElementDescription class methodsFor: 'instance-creation-selector' stamp: 'lr 3/27/2005 10:27'!
selector: aSelector label: aString priority: aNumber default: anObject
	^self accessor: (MASelectorAccessor selector: aSelector) label: aString priority: aNumber default: anObject.! !

!MAElementDescription class methodsFor: 'instance-creation-cascade' stamp: 'lr 4/6/2005 22:25'!
selectors: anArray
	^self accessor: (MACascadeAccessor selectors: anArray).! !

!MAElementDescription class methodsFor: 'instance-creation-cascade' stamp: 'lr 4/6/2005 22:26'!
selectors: anArray label: aString
	^self accessor: (MACascadeAccessor selectors: anArray) label: aString.! !

!MAElementDescription class methodsFor: 'instance-creation-cascade' stamp: 'lr 4/6/2005 22:26'!
selectors: anArray label: aString priority: aNumber
	^self accessor: (MACascadeAccessor selectors: anArray) label: aString priority: aNumber.! !

!MAElementDescription class methodsFor: 'instance-creation-cascade' stamp: 'lr 4/6/2005 22:26'!
selectors: anArray label: aString priority: aNumber default: anObject
	^self accessor: (MACascadeAccessor selectors: anArray) label: aString priority: aNumber default: anObject.! !

!MAElementDescription methodsFor: 'converting' stamp: 'lr 3/24/2005 12:19'!
asContainer
	^MAContainer with: self.! !

!MAElementDescription methodsFor: 'operators' stamp: 'lr 3/29/2005 20:00'!
collectionToString: aCollection
	^String streamContents: [ :stream |
		aCollection
			do: [ :each | stream nextPutAll: each asString ]
			separatedBy: [ stream cr ] ].! !

!MAElementDescription methodsFor: 'accessing-properties' stamp: 'lr 3/17/2005 16:16'!
comparators
	^MAComparator equalityComparators.! !

!MAElementDescription methodsFor: 'accessing' stamp: 'lr 3/27/2005 10:17'!
default
	^default! !

!MAElementDescription methodsFor: 'accessing' stamp: 'lr 3/27/2005 10:17'!
default: anObject
	default := anObject! !

!MAElementDescription methodsFor: 'testing' stamp: 'lr 3/23/2005 14:19'!
includes: anObject
	"Return true or false wether anObject is a proper value of the receiver."

	^anObject isKindOf: self kind.! !

!MAElementDescription methodsFor: 'accessing-properties' stamp: 'lr 3/23/2005 14:16'!
kind
	^self subclassResponsibility.! !

!MAElementDescription methodsFor: 'operators' stamp: 'lr 3/14/2005 16:12'!
migrate: anObject from: aDescription
	^self parseString: (aDescription toString: anObject).! !

!MAElementDescription methodsFor: 'operators' stamp: 'lr 3/14/2005 16:15'!
parseString: aString
	^self parseString: aString protected: [ aString ].! !

!MAElementDescription methodsFor: 'operators' stamp: 'lr 4/3/2005 12:26'!
parseString: aString protected: aBlock
	^aString isEmptyOrNil ifFalse: [ 
		aBlock
			on: Error
			do: [ :err | err return: aString ] ].! !

!MAElementDescription methodsFor: 'copying' stamp: 'lr 3/28/2005 11:29'!
postCopy
	super postCopy.
	self accessor: self accessor copy.
	self default: self default copy.! !

!MAElementDescription methodsFor: 'accessing-properties' stamp: 'lr 3/24/2005 00:40'!
sorter
	^MAComparator lessThanOrEqualTo.! !

!MAElementDescription methodsFor: 'operators' stamp: 'lr 3/29/2005 20:01'!
stringToCollection: aString default: aCollection
	^aString isEmptyOrNil
		ifTrue: [ aCollection ]
		ifFalse: [
			((aString findTokens: Character cr)
				collect: [ :each | each withBlanksCondensed ])
					select: [ :each | each notEmpty ] ].! !

!MAElementDescription methodsFor: 'operators' stamp: 'lr 3/21/2005 19:15'!
toString: anObject
	^anObject isNil
		ifTrue: [ String new ]
		ifFalse: [ anObject asLabel ].! !

MAElementDescription subclass: #MAMagnitudeDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

MAMagnitudeDescription subclass: #MADateDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MADateDescription class methodsFor: 'converting' stamp: 'lr 4/4/2005 18:34'!
asLabel
	^'Date Field'! !

!MADateDescription class methodsFor: 'testing' stamp: 'lr 3/19/2005 10:29'!
isAbstract
	^false! !

!MADateDescription methodsFor: 'accessing' stamp: 'lr 3/23/2005 14:16'!
kind
	^Date! !

MAMagnitudeDescription subclass: #MADurationDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MADurationDescription class methodsFor: 'converting' stamp: 'lr 4/4/2005 18:34'!
asLabel
	^'Duration Field'! !

!MADurationDescription class methodsFor: 'testing' stamp: 'lr 3/19/2005 10:29'!
isAbstract
	^false! !

!MADurationDescription methodsFor: 'accessing' stamp: 'lr 3/23/2005 14:17'!
kind
	^Duration! !

!MAMagnitudeDescription methodsFor: 'accessing' stamp: 'lr 3/17/2005 16:17'!
comparators
	^super comparators , MAComparator magnitudeComparators.! !

!MAMagnitudeDescription methodsFor: 'converting' stamp: 'lr 3/23/2005 14:19'!
parseString: aString
	^self parseString: aString protected: [ self kind fromString: aString ].! !

MAMagnitudeDescription subclass: #MANumberDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MANumberDescription class methodsFor: 'converting' stamp: 'lr 4/4/2005 18:34'!
asLabel
	^'Number Field'! !

!MANumberDescription class methodsFor: 'testing' stamp: 'lr 3/19/2005 10:29'!
isAbstract
	^false! !

!MANumberDescription methodsFor: 'accessing' stamp: 'lr 3/23/2005 14:16'!
kind
	^Number! !

!MANumberDescription methodsFor: 'converting' stamp: 'lr 3/14/2005 16:06'!
parseString: aString
	^self parseString: aString protected: [ aString asNumber ].! !

MAMagnitudeDescription subclass: #MATimeDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MATimeDescription class methodsFor: 'converting' stamp: 'lr 4/4/2005 18:34'!
asLabel
	^'Time Field'! !

!MATimeDescription class methodsFor: 'testing' stamp: 'lr 3/19/2005 10:30'!
isAbstract
	^false! !

!MATimeDescription methodsFor: 'accessing' stamp: 'lr 3/23/2005 14:16'!
kind
	^Time! !

MAMagnitudeDescription subclass: #MATimeStampDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MATimeStampDescription class methodsFor: 'converting' stamp: 'lr 4/4/2005 18:35'!
asLabel
	^'Timestamp Field'! !

!MATimeStampDescription class methodsFor: 'testing' stamp: 'lr 3/19/2005 10:30'!
isAbstract
	^false! !

!MATimeStampDescription methodsFor: 'accessing' stamp: 'lr 3/23/2005 14:17'!
kind
	^TimeStamp! !

MAElementDescription subclass: #MAOptionsDescription
	instanceVariableNames: 'options none'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MAOptionsDescription class methodsFor: 'converting' stamp: 'lr 4/4/2005 18:35'!
asLabel
	^'Option-Box'! !

!MAOptionsDescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/29/2005 20:19'!
defaultNone
	^String new.! !

!MAOptionsDescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/15/2005 18:38'!
defaultOptions
	^OrderedCollection new.! !

!MAOptionsDescription class methodsFor: 'accessing-description' stamp: 'lr 3/14/2005 12:16'!
descriptionDefault
	^nil! !

!MAOptionsDescription class methodsFor: 'accessing-description' stamp: 'lr 3/29/2005 20:19'!
descriptionNone
	^MAStringDescription selector: #none label: 'None Label' priority: 150.! !

!MAOptionsDescription class methodsFor: 'accessing-description' stamp: 'lr 3/29/2005 20:19'!
descriptionOptions
	^MATextDescription selector: #optionsTextual label: 'Options' priority: 160.! !

!MAOptionsDescription class methodsFor: 'testing' stamp: 'lr 3/19/2005 10:30'!
isAbstract
	^false! !

!MAOptionsDescription methodsFor: 'testing' stamp: 'lr 3/11/2005 22:38'!
includes: anObject
	^self options includes: anObject.! !

!MAOptionsDescription methodsFor: 'accessing' stamp: 'lr 3/23/2005 14:17'!
kind
	^Object! !

!MAOptionsDescription methodsFor: 'accessing' stamp: 'lr 3/29/2005 20:19'!
none
	none isNil
		ifTrue: [ self none: self class defaultNone ].
	^none.! !

!MAOptionsDescription methodsFor: 'accessing' stamp: 'lr 3/29/2005 20:20'!
none: aString
	none := aString! !

!MAOptionsDescription methodsFor: 'accessing' stamp: 'lr 3/14/2005 19:22'!
options
	options isNil
		ifTrue: [ self options: self class defaultOptions ].
	^options.! !

!MAOptionsDescription methodsFor: 'accessing' stamp: 'lr 3/11/2005 22:37'!
options: aCollection
	options := aCollection! !

!MAOptionsDescription methodsFor: 'accessing' stamp: 'lr 3/15/2005 18:38'!
optionsTextual
	^self collectionToString: self options.! !

!MAOptionsDescription methodsFor: 'accessing' stamp: 'lr 3/15/2005 18:38'!
optionsTextual: aString
	self options: (self stringToCollection: aString default: self class defaultOptions).! !

!MAOptionsDescription methodsFor: 'copying' stamp: 'lr 3/11/2005 22:36'!
postCopy
	super postCopy.
	self options: self options copy.! !

MAElementDescription subclass: #MAStringDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

MAStringDescription subclass: #MAPasswordDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MAPasswordDescription class methodsFor: 'converting' stamp: 'lr 4/4/2005 18:36'!
asLabel
	^'Password Field'! !

!MAPasswordDescription methodsFor: 'testing' stamp: 'lr 4/6/2005 23:24'!
isObfuscated: anObject
	^anObject notNil
		and: [ anObject isString ] 
		and: [ anObject allSatisfy: [ :each | each = $* ] ].! !

!MAPasswordDescription methodsFor: 'operators' stamp: 'lr 4/6/2005 23:26'!
obfuscated: anObject
	^String new: (self toString: anObject) size withAll: $*.! !

!MAStringDescription class methodsFor: 'converting' stamp: 'lr 4/4/2005 18:34'!
asLabel
	^'Text Field'! !

!MAStringDescription class methodsFor: 'testing' stamp: 'lr 3/19/2005 10:30'!
isAbstract
	^false! !

!MAStringDescription methodsFor: 'accessing' stamp: 'lr 3/23/2005 15:12'!
comparators
	^super comparators , MAComparator stringComparators.! !

!MAStringDescription methodsFor: 'accessing' stamp: 'lr 3/23/2005 14:17'!
kind
	^String! !

MAStringDescription subclass: #MASymbolDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MASymbolDescription class methodsFor: 'converting' stamp: 'lr 4/4/2005 18:36'!
asLabel
	^'Symbol Field'! !

!MASymbolDescription methodsFor: 'accessing' stamp: 'lr 3/23/2005 14:17'!
kind
	^Symbol! !

!MASymbolDescription methodsFor: 'converting' stamp: 'lr 3/14/2005 16:06'!
parseString: aString
	^self parseString: aString protected: [ aString asSymbol ].! !

MAStringDescription subclass: #MATextDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MATextDescription class methodsFor: 'converting' stamp: 'lr 4/4/2005 18:36'!
asLabel
	^'Memo Field'! !

MAElementDescription subclass: #MATableDescription
	instanceVariableNames: 'rowLabels columnLabels cellDescription'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MATableDescription class methodsFor: 'converting' stamp: 'lr 4/4/2005 18:34'!
asLabel
	^'Table'! !

!MATableDescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/16/2005 20:33'!
defaultCellDescription
	^self defaultCellDescriptionClasses first new.! !

!MATableDescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/17/2005 15:12'!
defaultCellDescriptionClasses
	^Array 
		with: MAStringDescription
		with: MATextDescription
		with: MANumberDescription
		with: MABooleanDescription.! !

!MATableDescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/15/2005 22:37'!
defaultColumnLabels
	^OrderedCollection new! !

!MATableDescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/15/2005 22:37'!
defaultDefault
	^Array new! !

!MATableDescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/15/2005 22:37'!
defaultRowLables
	^OrderedCollection new! !

!MATableDescription class methodsFor: 'accessing-description' stamp: 'lr 3/29/2005 20:23'!
descriptionCellDescription
	^(MAOptionsDescription selector: #cellDescription label: 'Type' priority: 270 default: self defaultCellDescription)
		options: (self defaultCellDescriptionClasses collect: [ :each |
			each new
				label: each description label; 
				yourself ]);
		beRequired;
		yourself.! !

!MATableDescription class methodsFor: 'accessing-description' stamp: 'lr 3/27/2005 10:37'!
descriptionColumnLabels
	^MATextDescription selector: #columnLabelsTextual label: 'Column Labels' priority: 250.! !

!MATableDescription class methodsFor: 'accessing-description' stamp: 'lr 3/15/2005 09:06'!
descriptionDefault
	^nil! !

!MATableDescription class methodsFor: 'accessing-description' stamp: 'lr 3/15/2005 09:20'!
descriptionRequired
	^nil! !

!MATableDescription class methodsFor: 'accessing-description' stamp: 'lr 3/27/2005 10:37'!
descriptionRowLabels
	^MATextDescription selector: #rowLabelsTextual label: 'Row Labels' priority: 260.! !

!MATableDescription class methodsFor: 'testing' stamp: 'lr 3/19/2005 10:30'!
isAbstract
	^false! !

!MATableDescription methodsFor: 'accessing-dynamic' stamp: 'lr 3/29/2005 20:59'!
cellCount
	^self columnCount * self rowCount.! !

!MATableDescription methodsFor: 'accessing' stamp: 'lr 3/16/2005 20:26'!
cellDescription
	cellDescription isNil
		ifTrue: [ self cellDescription: self class defaultCellDescription ].
	^cellDescription.! !

!MATableDescription methodsFor: 'accessing' stamp: 'lr 3/16/2005 20:27'!
cellDescription: aDescription
	cellDescription := aDescription.! !

!MATableDescription methodsFor: 'accessing-dynamic' stamp: 'lr 3/15/2005 22:38'!
columnCount
	^self columnLabels size.! !

!MATableDescription methodsFor: 'accessing' stamp: 'lr 3/15/2005 22:35'!
columnLabels
	columnLabels isNil 
		ifTrue: [ self columnLabels: self class defaultColumnLabels ].
	^columnLabels.! !

!MATableDescription methodsFor: 'accessing' stamp: 'lr 3/15/2005 22:35'!
columnLabels: aCollection
	columnLabels := aCollection! !

!MATableDescription methodsFor: 'accessing-conveniance' stamp: 'lr 3/15/2005 22:36'!
columnLabelsTextual
	^self collectionToString: self columnLabels.! !

!MATableDescription methodsFor: 'accessing-conveniance' stamp: 'lr 3/15/2005 22:36'!
columnLabelsTextual: aString
	^self columnLabels: (self stringToCollection: aString default: self class defaultColumnLabels).! !

!MATableDescription methodsFor: 'accessing-indexes' stamp: 'lr 3/29/2005 21:05'!
columnOfIndex: anInteger
	| index |
	index := anInteger \\ self columnCount.
	^index isZero
		ifTrue: [ self columnCount ]
		ifFalse: [ index ].! !

!MATableDescription methodsFor: 'testing' stamp: 'lr 3/29/2005 21:17'!
includes: anObject
	^(super includes: anObject)
		and: [ self cellCount = anObject size ].! !

!MATableDescription methodsFor: 'accessing-indexes' stamp: 'lr 3/29/2005 21:05'!
indexAt: aRowIndex at: aColIndex
	^aRowIndex - 1 * self columnCount + aColIndex.! !

!MATableDescription methodsFor: 'accessing-dynamic' stamp: 'lr 3/23/2005 14:17'!
kind
	^SequenceableCollection! !

!MATableDescription methodsFor: 'copying' stamp: 'lr 3/16/2005 20:27'!
postCopy
	super postCopy.
	self rowLabels: self rowLabels copy.
	self columnLabels: self columnLabels copy.
	self cellDescription: self cellDescription copy.! !

!MATableDescription methodsFor: 'accessing-dynamic' stamp: 'lr 3/15/2005 22:11'!
rowCount
	^self rowLabels size.! !

!MATableDescription methodsFor: 'accessing' stamp: 'lr 3/15/2005 09:06'!
rowLabels
	rowLabels isNil 
		ifTrue: [ self rowLabels: self class defaultRowLables ].
	^rowLabels.! !

!MATableDescription methodsFor: 'accessing' stamp: 'lr 3/15/2005 08:50'!
rowLabels: aCollection
	rowLabels := aCollection! !

!MATableDescription methodsFor: 'accessing-conveniance' stamp: 'lr 3/15/2005 08:56'!
rowLabelsTextual
	^self collectionToString: self rowLabels.! !

!MATableDescription methodsFor: 'accessing-conveniance' stamp: 'lr 3/15/2005 08:57'!
rowLabelsTextual: aString
	^self rowLabels: (self stringToCollection: aString default: self class defaultRowLables).! !

!MATableDescription methodsFor: 'accessing-indexes' stamp: 'lr 3/29/2005 21:05'!
rowOfIndex: anInteger
	^anInteger - 1 // self columnCount + 1.! !

!MATableDescription methodsFor: 'accessing-properties' stamp: 'lr 4/6/2005 22:49'!
sorter
	^nil! !

Object subclass: #MAObjectStreaming
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Utility'!

MAObjectStreaming subclass: #MAObjectReader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Utility'!

!MAObjectStreaming class methodsFor: 'instance creation' stamp: 'lr 3/19/2005 12:33'!
on: aStream
	^self new
		setStream: aStream;
		yourself.! !

!MAObjectStreaming methodsFor: 'initialization' stamp: 'lr 3/19/2005 13:01'!
setStream: aStream
	stream := aStream! !

!MAObjectStreaming methodsFor: 'accessing' stamp: 'lr 3/19/2005 12:59'!
stream
	^stream! !

MAObjectStreaming subclass: #MAObjectWriter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Utility'!

!MAObjectWriter methodsFor: 'as yet unclassified' stamp: 'lr 3/19/2005 13:29'!
nextPut: anObject
	" not working, need something more sofisticated than this "

	self stream 
		nextPutAll: 't1 := '; 
		nextPutAll: anObject class name; 
		nextPutAll: ' basicNew.'; 
		cr.
	anObject description do: [ :each |
		(each isPersistent and: [ each isReadonly not ]) ifTrue: [
			self stream 
				nextPutAll: 'd := t1 description at: '; 
				print: each key; 
				nextPutAll: '.'; 
				cr.
			self stream 
				nextPutAll: 'd write: (d parseString: '; 
				print: (each toString: (each read: anObject)); 
				nextPutAll: ') to: t1.';
				cr ] ].! !

Object subclass: #MAScaffolder
	instanceVariableNames: 'values'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Utility'!

MAScaffolder subclass: #MADescribedScaffolder
	instanceVariableNames: 'description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Utility'!

!MADescribedScaffolder methodsFor: 'accessing' stamp: 'lr 4/4/2005 10:20'!
description
	^description! !

!MADescribedScaffolder methodsFor: 'accessing' stamp: 'lr 4/4/2005 10:21'!
description: aDescription
	description := aDescription! !

!MADescribedScaffolder methodsFor: 'initialization' stamp: 'lr 4/4/2005 10:22'!
initialize
	super initialize.
	self description: self class defaultContainer.! !

!MAScaffolder class methodsFor: 'instance creation' stamp: 'lr 3/28/2005 22:44'!
description: aDescription
	^self new
		description: aDescription;
		yourself.! !

!MAScaffolder methodsFor: 'initialization' stamp: 'lr 4/4/2005 10:21'!
initialize
	super initialize.
	self values: IdentityDictionary new.! !

!MAScaffolder methodsFor: 'private' stamp: 'lr 4/6/2005 23:16'!
readUsing: aDescription
	^aDescription isContainer
		ifTrue: [ super readUsing: aDescription ]
		ifFalse: [ 
			self values 
				at: aDescription
				ifAbsentPut: [ aDescription default ] ].! !

!MAScaffolder methodsFor: 'accessing' stamp: 'lr 3/21/2005 19:30'!
values
	^values! !

!MAScaffolder methodsFor: 'accessing' stamp: 'lr 3/21/2005 19:30'!
values: aDictionary
	values := aDictionary! !

!MAScaffolder methodsFor: 'private' stamp: 'lr 4/6/2005 23:16'!
write: anObject using: aDescription
	^aDescription isContainer
		ifTrue: [ super write: anObject using: aDescription ]
		ifFalse: [ 
			self values 
				at: aDescription
				put: anObject ].! !

!Object class methodsFor: '*Magritte-Core-converting' stamp: 'lr 4/4/2005 18:30'!
asLabel
	^self name! !

!Object class methodsFor: '*Magritte-Core-defaults' stamp: 'lr 4/4/2005 18:31'!
defaultContainer
	"Return the default description container."
	
	^MAPriorityContainer new 
		label: self asLabel;
		yourself.! !

!Object class methodsFor: '*Magritte-Core-accessing' stamp: 'lr 4/5/2005 20:09'!
description
	^MACachedBuilder default build: self.! !

!Object methodsFor: '*Magritte-Core-converting' stamp: 'lr 3/10/2005 22:20'!
asLabel
	^self asString.! !

!Object methodsFor: '*Magritte-Core-defaults' stamp: 'lr 4/7/2005 23:21'!
defaultWrapperClass
	^MACheckedWrapper! !

!Object methodsFor: '*Magritte-Core-accessing' stamp: 'lr 3/9/2005 22:24'!
description
	"Return the description of the reciever. Subclasses might override this message to return instance-based descriptions."
	
	^self class description.! !

!Object methodsFor: '*Magritte-Core-model' stamp: 'lr 4/4/2005 17:33'!
readUsing: aDescription
	"Dispatch the read-access to the receiver using the accessor of aDescription."

	^aDescription accessor read: self.! !

!Object methodsFor: '*Magritte-Core-model' stamp: 'lr 4/4/2005 17:33'!
write: anObject using: aDescription
	"Dispatch the write-access to the receiver of anObject using the accessor of aDescription."

	aDescription accessor write: anObject to: self.! !

!Integer methodsFor: '*Magritte-Core-converting' stamp: 'lr 4/4/2005 21:18'!
asFileSize
	#( 'B' 'KB' 'MB' 'GB' 'TB' 'PB' 'EB' 'ZB' 'YB' )
		inject: self
		into: [ :value :each |
			value < 1024
				ifFalse: [ value // 1024 ]
				ifTrue: [ ^value asString , ' ' , each ] ].! !

!True methodsFor: '*Magritte-Core-converting' stamp: 'lr 3/10/2005 22:21'!
asLabel
	^ 'yes'! !
MAComparator initialize!
